/*==================================================================*/
/*    File:  PrePost.cpp                                            */
/*    Demonstrate how to overload the prefix and postfix increment  */
/*    and decrement operators using member functions and friend     */
/*    functions.                                                    */
/*==================================================================*/

#include <iostream.h>

/*==================================================================*/
/*    class PrePostMe(mber)                                         */
/*==================================================================*/

class PrePostMe        // overloading ++ and -- using MEMBER functions
{
  public:
    PrePostMe ()
        {  nX = 0;  }

    PrePostMe (const int nValue)
        {  nX = nValue;  }

    // overload PREFIX ++ as a MEMBER function
    int operator ++ ()
        {  return (++nX);  }

    // overloaded POSTFIX ++ as a MEMBER function
    int operator -- (int nDummy)
        {  return (nX--);  }

    // overload << for output of a PrePostMe object
    friend ostream& operator << (ostream& outs, const PrePostMe ppM)
        {  outs << ppM.nX;  return outs;  }

  private:
    int  nX;
};    // end class PrePostMe

/*==================================================================*/
/*    class PrePostFr(iend)                                         */
/*==================================================================*/

class PrePostFr        // overloading ++ and -- using FRIEND functions
{
  public:
    PrePostFr ()
        { nX = 0; }

    PrePostFr (const int nValue)
        {  nX = nValue;  }

    // overload PREFIX ++ as a FRIEND function
    friend int operator ++ (PrePostFr& rPrePostFr)
        {  return (++rPrePostFr.nX);  }

    // overloaded POSTFIX ++ as a FRIEND function
    friend int operator -- (PrePostFr& rPrePostFr, int nDummy)
        {  return (rPrePostFr.nX--);  }

    // overload << for output of a PrePostFr object
    friend ostream& operator << (ostream& outs, const PrePostFr ppF)
        {  outs << ppF.nX;  return outs;  }

  private:
    int  nX;
};    // end class PrePostFr

/*==================================================================*/
/*    the main routine                                              */
/*==================================================================*/

int main (void)
{
    PrePostFr x (4), y (7);

    cout << "Overloading Prefix and Postfix ++ and --" << endl << endl;

    cout << "Initial x=" << x << "   ++x=";
    cout << ++x << "   Final value of x is ";
    cout << x << endl;
    cout << "Initial y=" << y << "   y--=";
    cout << y-- << "   Final value of y is ";
    cout << y << endl << endl;

    cout << "Overloading Prefix and Postfix ++ and --" << endl << endl;

    PrePostMe u (4), v (7);

    cout << "Initial u=" << u << "   ++u=";
    cout << ++u << "   Final value of u is ";
    cout << u << endl;
    cout << "Initial v=" << v << "   v--=";
    cout << v-- << "   Final value of v is ";
    cout << v << endl << endl;

    cout << "End Demo" << endl << endl;
    return 0;
}

/*==================================================================*/
/*     Output from the above program                                */
/*==================================================================*/

/* ----- Output -----

Overloading Prefix and Postfix ++ and --

Initial x=4   ++x=5   Final value of x is 5
Initial y=7   y--=7   Final value of y is 6

Overloading Prefix and Postfix ++ and --

Initial u=4   ++u=5   Final value of u is 5
Initial v=7   v--=7   Final value of v is 6

End Demo

----- End Output ----- */
